#include <cflib.h>
#include <fcntl.h>
#include <support.h>

#include "mt_aes.h"

extern _app;

#define MAX_STR_LEN 1024
#define AL_MSG	0x0001

char	*err_msg;
long	pipe_fd;
char 	alert_buf[MAX_STR_LEN+1];

/*
 * Select-Threat:
 * Mit Fselect wird die Pipe berwacht. Sobald dort etwas anliegt wird es
 * ausgelesen und dem Hauptprogramm eine Message geschickt, so da dieses
 * den Alert anzeigt.
*/
short	th_global[16];
int	th_apid;

int watch_pipe(long parm)
{
	long	mask = 0L, r;
	short	msg[8];
	char	menu_str[] = "  (alert)";
	
	th_apid = mt_appl_init(th_global);
/*
	Wieso geht das nicht??
	Wenn man statt -1 th_apid benutzt, werden beide Eintrge gendert!
	mt_menu_register(-1, menu_str, th_global);
*/
	while (TRUE)
	{
		mask |= (1L << pipe_fd);
		r = Fselect(0, &mask, 0L, 0L);
		if (r > 0)
		{
			if (mask & (1L << pipe_fd)) 
			{
				if ((r = Fread((int)pipe_fd, (long)sizeof(alert_buf), alert_buf)) > 1)
				{
					if (alert_buf[0] == '[' &&	alert_buf[r-2] == ']' && alert_buf[r-1] == 0)
					{
						msg[0] = AL_MSG;
						msg[1] = th_apid;
						msg[2] = 0;	msg[3] = 0; msg[4] = 0; 
						msg[5] = 0;	msg[6] = 0;	msg[7] = 0;
						mt_appl_write(gl_apid, sizeof(msg), msg, th_global);
					}			
					else
						alert_buf[0] = 0;
				}
			}
		}
	}
	return 0;	
}

/*
 * Hauptprogramm
*/
void alert_err(char *msg)
{
	short	message[8];

	strcpy(err_msg, msg);
	for (;;)
	{
		evnt_mesag(message);
		if (message[0] == AC_OPEN)
			form_alert(1, err_msg);
	}
}

void main(void)
{
	long	v;
	short	message[8];
	int 	d, event;
	char	menu_str[] = "  Alerts";
	
	appl_init();
	if (_app)
	{
		form_alert(1, "[1][Can only run as ACC][Exit]");
		appl_exit();
		exit(0);
	}
	
	if (!getcookie("MiNT", &v))
		alert_err("[1][MiNT not running][Exit]");
	
	menu_register(gl_apid, menu_str);

	pipe_fd = Fopen("u:\\pipe\\alert", O_RDWR|O_CREAT|O_TRUNC|O_NDELAY|O_DENYNONE);
	if (pipe_fd < 0)
		alert_err("[1][Couldn't create Alert pipe][Exit]");
	
	/*
	 * since we are running as an Accessory, the owner of the
	 * file is GEM, so we must clear the close-on-exec flag,
	 * or GEM will raise an BUS-Error when executing programs
	 */
	Fcntl((int)pipe_fd, 0l, F_SETFD);
		
	alert_buf[0] = '\0';
	tfork(watch_pipe, 0);
	while (TRUE)
	{
		event = evnt_multi(MU_MESAG, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
									message, 0L, &d, &d, &d, &d, &d, &d);
		if (event & MU_MESAG)
		{
			if (message[0] == AL_MSG)
			{
				graf_mouse(ARROW, NULL);
				form_alert(1, alert_buf);
			}
			if (message[0] == AC_OPEN)
			{
				if (alert_buf[0] == '\0')
					form_alert(1, "[1][No alerts yet][OK]");
				else
					form_alert(1, alert_buf);
			}
		}
	}
}
